// thread3.cpp
// Glenn G. Chappell
// 6 Feb 2013
//
// For CS 321 Spring 2013
// Threads with Race Condition

#include <iostream>
using std::cout;
using std::endl;
#include <thread>
using std::thread;


int count;         // Counter; we want to limit this to 3


// Run function for spawned threads
// Increment global count if it is less than 3.
// Sadly, not thread-safe
void run(int n)
{
    if (count < 3)
    {
        cout << "count is low; incrementing" << endl;
        ++count;
    }
    else
    {
        cout << "count is high; NOT incrementing" << endl;
    }
}


int main()
{
    count = 0;
    cout << "Master: start count = " << count << endl;

    thread t1(run, 1);
    thread t2(run, 2);
    thread t3(run, 3);
    thread t4(run, 4);
    thread t5(run, 5);

    t1.join();
    t2.join();
    t3.join();
    t4.join();
    t5.join();

    cout << "Master: end count = " << count << endl;
    cout << "Master: (We want the above to be " << 3 << ")" << endl;

    return 0;
}

